<!DOCTYPE html>
<html>

<head>
    <title>Vergleichsresultat</title>

    <meta name="viewport" content="width=device-width, initial-scale=1.0">

<!--
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.1/dist/css/bootstrap.min.css" rel="stylesheet"
        integrity="sha384-4bw+/aepP/YC94hEpVNVgiZdgIC5+VKNBQNGCHeKRQN+PtmoHDEXuppvnDJzQIu9" crossorigin="anonymous">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.1/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-HwwvtgBNo3bZJJLYd8oVXjrBZt8cqVSpeBNS5n7C8IVInixGAoxmnlMuBnhbgrkm"
        crossorigin="anonymous"></script>
    <script src="https://code.jquery.com/jquery-3.7.1.min.js"
        integrity="sha256-/JqT3SQfawRcv/BIHPThkBvs0OEvtFFmqPF/lYI/Cxo=" crossorigin="anonymous"></script>
    <script src="https://cdn.datatables.net/1.13.6/js/jquery.dataTables.min.js" integrity="sha384-k5vbMeKHbxEZ0AEBTSdR7UjAgWCcUfrS8c0c5b2AfIh7olfhNkyCZYwOfzOQhauK" crossorigin="anonymous"></script>
    <link rel="stylesheet" href="https://cdn.datatables.net/1.13.6/css/jquery.dataTables.min.css" integrity="sha384-w9ufcIOKS67vY4KePhJtmWDp4+Ai5DMaHvqqF85VvjaGYSW2AhIbqorgKYqIJopv" crossorigin="anonymous">
-->

    {% load static %}
    <link rel="shortcut icon" type="image/png" href="{% static 'images/favicon.ico' %}" >
    <link href="{% static 'script/bootstrap.min.css' %}" rel="stylesheet">
    <script src="{% static 'script/bootstrap.bundle.min.js' %}"></script>
    <script src="{% static 'script/jquery-3.7.1.min.js' %}"></script>
    <script src="{% static 'script/jquery.dataTables.min.js' %}"></script>
    <link rel="stylesheet" href="{% static 'script/jquery.dataTables.min.css' %}">

    <style>
        * {
            box-sizing: border-box;
        }
        html {
            height: 100%;
            scroll-behavior: smooth;
        }
        body {
            position: relative;
            background-color: #ccc;
        }
        th,
        td {
            border: 1px solid black;
            padding: 8px;
            text-align: center;
            word-wrap: break-word;
            white-space: nowrap;
            max-width: 50px;
            overflow: hidden;
            text-overflow: ellipsis;
        }
        tr:not(.table-success).odd > td  {
            background-color: beige;
        }
/*
        th {
            background-color: #f2f2f2;
        }
*/

        .container {
            max-width: 800px;
            margin: 0 auto;
        }

        /* tbody,
        td,
        tfoot,
        th,
        thead,
        tr {
            max-width: 60px;
            overflow-y: hidden;
        }
*/
        .tableDivContent {
            width: 50%;
        }
        .d-none + #pageContentDiv {
            height: 100vh !important;
        }
        nav:not(.d-none) + #pageContentDiv {
            border: none !important;
            padding-top: 0.25rem!important;
        }
        #pageContentDiv {
            height: 100vh !important;
            overflow: auto !important;
            background-color: #ccc;
        }
        nav {
            background-color: #ccc;
            --bs-breadcrumb-divider: '>';
        }
        .breadcrumb {
            margin: 0;
        }
        .breadcrumb a {
            color: rgba(33,37,41);
            text-decoration: none;
        }

        .breadcrumb a:hover {
            text-decoration: underline;
        }

        .headerDiv {
            display: none;
            background-color: #ccc;
            position: absolute;
            padding: 10px;
            z-index: 1500;
            width: 100%;
            height: 100%;
            top: 0px;
            left: 0px;
        }

        .footer {
            position: fixed;
            width: 100%;
            height: 110vh !important;
            top: 0;
            left: 0;
            background-color: rgba(0, 0, 0, 0.8) !important;
            display: none;
        }

        .footer-container {
            position: relative;
            width: 1000px;
            left: calc(50% - 500px);
            top: calc(50% - 210.5px);
        }

        .dataTables_wrapper {
            margin: 82px auto 0px;
        }

        .dataTables_wrapper .dataTables_filter {
            margin-bottom: -2.75rem;
            margin-top: 0.5rem;
            position: relative;
            z-index: 1000;
        }

        .dataTables_wrapper .dataTables_filter input {
            background-color: #fff;
            outline: none;
            border: 1px solid #000;
            border-radius: 0;
        }
        nav {
            border-bottom: 1px solid #000;
        }
        .menu-icon {
            border-bottom: 1px solid #000;
            position: sticky;
            top: 0px;
            z-index: 1020;
        }

        .current-different-div{
            /* background-color: yellow; */
            display: none;
            /* padding: 5px; */
            padding-left: 30px;
            padding-right: 30px;
            text-align: center;
            /* color: red; */
            position: absolute;
            z-index: 1500;
            width: 100%;
            font-weight: bold;
            border: 1px solid #000;
            border-top: none;
        }
        .error-div{
            background-color: yellow;
            /* padding: 10px; */
            padding-left: 30px;
            padding-right: 30px;
            /* text-align: center; */
            color: red;
            position: fixed;
            z-index: 1501;
            width: 100%;
            overflow:scroll;
            max-width:98%;
            max-height:85%
        }

        #quote {
            margin-bottom: 7.5px;
        }

        .container-xl {
            padding-left: 0px;
            margin-left: 0;
        }

        .container-xl .input-group-text {
            width: 85px;
            justify-content: center;
        }

        .container-xl .save-field {
            padding: 7.5px 0px;
        }

        .footer-container .btn-save {
            margin-top: 7.5px;
        }

        .bg-yellow {
            background-color: #F4F5DB;
            color: #000 !important;
            border: 1px solid #000;
            padding: 0.5rem !important;
        }
    </style>
</head>

<body>
    {% csrf_token %}
    <div class="sticky-top">
        <div class="menu-icon bg-light text-center p-2" id="menu-icon" role='button'>Nicht-Übereinstimmungen anzeigen</div>
        <div id="current-different-div" class="current-different-div bg-light"></div>
        <nav class="p-2 d-none" aria-label="breadcrumb">
            <ol class="breadcrumb" id="breadcrumb">
            </ol>
        </nav>
    </div>
    <div id="error-div" class="error-div" style="display: none;">
        <div id="err-text"></div>
        <button id="btnCloseError" type="button" class="btn btn-secondary btn-lg">Close</button>
    </div>
    <div class="headerDiv">
        <a href="/">Zurcük zum Download</a>
        <div class="container-fluid grid gap-3 p-2" id="headerDivJsAfterUpdate">
            Hier werden die Änderungen angezeigt
        </div>
    </div>
    <div id="main">

        <div  id="pageContentDiv">
            Hier werden die Datenbanktabellen angezeigt
        </div>
    </div>
    <div class="sticky-bottom bg-col footer" id="headerDivJs">
        <div class="headerDivMessage p-2" id="headerDivMessageJs">
        </div>
        <div class="footer-container bg-light p-5">
            <div id="quote" class="showWhenBoth">
                Text-Ähnlichkeitsquote: <span></span>&percnt;
            </div>
            <div class="showWhenLeft">
                <div class="container-xl">
                    <div class="d-flex flex-row save-field">
                        <div class="d-flex flex-row w-100">
                            <span class="input-group-text">Links</span>
                            <textarea id="textAreaJsD1" class="form-control" aria-label="With textarea"></textarea>
                            <button id="btnCopyLeftToRight" type="button" class="btn btn-secondary btn-lg showWhenBoth" title="Zum anderen Feld kopieren">&#8681;</button>
                        </div>
                    </div>
                </div>
            </div>
            <div class="showWhenRight">
                <div class="container-xl">
                    <div class="d-flex flex-row save-field">
                        <div class="d-flex flex-row w-100">
                            <span class="input-group-text">Rechts</span>
                            <textarea id="textAreaJsD2" class="form-control" aria-label="With textarea"></textarea>
                            <button id="btnCopyRightToLeft" type="button" class="btn btn-secondary btn-lg showWhenBoth" title="Zum anderen Feld kopieren">&#8679;</button>
                        </div>
                    </div>
                </div>
            </div>
            <div class="d-flex flex-row justify-content-end">
                <button id="save" type="button" class="btn btn-primary btn-lg btn-save">Speichern</button>
            </div>
        </div>
    </div>



    <script>
        $(document).ready(function () {
            $.ajaxSetup({
                beforeSend: function(xhr, settings) {
                    xhr.setRequestHeader("X-CSRFToken", $('input[name="csrfmiddlewaretoken"]').attr('value'));
                }
            });
            const constLeftDB = 'Left';
            const constRightDB = 'Right';

            var usedBSClasses = ['bg-secondary', 'table-success', 'bg-info','bg-danger'];
            //all to cleared Styling-classes must to be added to this List


            post('jqp_get_tables', { 'leftDb': localStorage['leftDb'], 'rightDb': localStorage['rightDb'] }, loadTables);
            $('#btnCopyLeftToRight').click(()=>{
                var value = $('#textAreaJsD1').val();
                $('#textAreaJsD2').val(value);
            });
            $('#btnCopyRightToLeft').click(()=>{
                var value = $('#textAreaJsD2').val();
                $('#textAreaJsD1').val(value);
            });
            $('#btnCloseError').click(()=>{
                var errorDiv = $('#error-div');
                errorDiv.hide();
                errorDiv.find('#err-text').empty();
            });

            function getTableId(leftOrRight, table_name){
                return leftOrRight + '_' + table_name;
            }

            function getCellId(leftOrRight, tableName, rowid, columnName){
                return leftOrRight + tableName + rowid + columnName;
            }

            function getRows(leftOrRight ,list, headers, tableName) {
                // console.log(list);
                let tableSt = "";
                if (list.length <= 0) return "";
                let size = list[0].length;
                //console.log(size);
                list.forEach(function (cellValue, i) {
                    tableSt += `<tr class="rowId${cellValue[0]}Js">`;
                    for (let cell_index = 0; cell_index < size; cell_index++) {
                        let id = getCellId(leftOrRight, tableName, cellValue[0],  headers[cell_index]);
                        if (cell_index == 0) id += '_0'; //um gleiche ids zu vermeiden, da id-spalte doppelt vorkommt
                        tableSt += `<td id="${id}" data-column-index="${cell_index}" data-columnname="${headers[cell_index]}" class="${headers[cell_index]}" title="${cellValue[cell_index]}">${cellValue[cell_index]}</td>`;
                    }
                    tableSt += "</tr>";
                });
                return tableSt;
            }
            function getColumnsHeader(list) {
                let tableSt = "<tr>";
                let size = list.length
                for (let index = 0; index < size; index++) {
                    tableSt += `<th title='${list[index]}'> ${list[index]} </th>`;
                }
                tableSt += "</tr>";
                return tableSt;
            }

            function loadTables(data){

                var sb = "";
                for (let index = 0; index < data.db_tablesL.length; index++) {
                    if (data.db_tablesL[index].table_name == 'rpl_paper'){
                        sb += createTablesTwinsDiv(data.db_tablesL[index], data.db_tablesR[index]);
                        break;
                    }
                }
                for (let index = 0; index < data.db_tablesL.length; index++) {
                    if (data.db_tablesL[index].table_name != 'rpl_paper'){
                        sb += createTablesTwinsDiv(data.db_tablesL[index], data.db_tablesR[index]);
                    }
                }

                $("#pageContentDiv").html(sb);
                createClickHandler();
                post('jqp_get_differents', null, store_differents);

                //hide first id column -there is another one and usually it is beside it-
                $("#pageContentDiv").find('thead').find('th:first-child').hide();
                $("#pageContentDiv").find("td[data-column-index='0']").hide();


                if(typeof DataTable != "undefined"){
                    $("#pageContentDiv").find('table').each(function(){
                        new DataTable(this, {"bPaginate": false, info: false, scrollCollapse: true,scrollY: '250px', "scrollX": true, "autoWidth": false , "oLanguage": {"sSearch": ""}});
                    });

                    $('input[type="search"]').prop('placeholder', 'search...')
                }
                // $('h5').click(function(){
                //     var tableName = $(this).closest('div.tableDivContent').data('table-name');
                //     // var dbName = $(this).closest('div.tableDivContent').data('dbname');
                //     // console.log('clicked');
                //     // $('#' + getTableId(dbName, tableName)).DataTable().columns.adjust().draw();
                //     $('#' + getTableId(constLeftDB, tableName)).DataTable().columns.adjust().draw();
                //     $('#' + getTableId(constRightDB, tableName)).DataTable().columns.adjust().draw();

                // });
            }
            function createTablesTwinsDiv(tableL, tableR){
                var tablesContent = "";
                tablesContent += `<div id="${tableL.table_name}-TablesTwinsDiv">`;
                tablesContent += '<div style="display: flex;">';
                tablesContent += creatTableDiv(tableL, constLeftDB);
                tablesContent += creatTableDiv(tableR, constRightDB);
                tablesContent += "</div>";
                tablesContent += `</div>`;
                return tablesContent;
            }

            function creatTableDiv(table, leftOrRight){
                var divAndTableContent = "";
                divAndTableContent += `<div class="container tableDivContent" id="${table.table_name}-TableDiv-${leftOrRight}" data-dbname="${leftOrRight}" data-table-name="${table.table_name}">`;
                // divAndTableContent += `<h5 data-dbname="${leftOrRight}">${table.table_name}</h5>`;
                var tableId = getTableId(leftOrRight, table.table_name);
                divAndTableContent += `<table id='${tableId}' class='table caption-top'>`;
                divAndTableContent += `<caption><h5 data-dbname="${leftOrRight}">${table.table_name}</h5></caption>`;
                divAndTableContent += "<thead>";
                divAndTableContent += getColumnsHeader(table.headers);
                divAndTableContent += "</thead><tbody>";
                divAndTableContent += getRows(leftOrRight, table.rows.values, table.headers, table.table_name);
                divAndTableContent += "</tbody></table></div>";
                return divAndTableContent;
            }

            function createClickHandler(){
                var cells = $("#pageContentDiv").find("td");
                // console.log(cells);
                for (i = 0; i < cells.length; i++) {
                    var currentCell = cells[i];
                    var createClickHandler = function(cell) {
                        return function() {
                            var cellName = cell;
                            var tableName = $(cell).closest('div.tableDivContent').data('table-name');
                            var dbName = $(cell).closest('div.tableDivContent').data('dbname');
                            var id = $(cell).closest('tr').find('td:first-child').text();
                            var columnIndex = cell.dataset.column;
                            var columnname = cell.dataset.columnname;

                            //console.log("dbName:" + dbName +"     tableName: " + tableName + "     id:" + id + "     column:" + column + "     columnName:" + columnname);

                            changeCell(dbName, tableName, id, columnname, 'bg-info');
                            openFooter(dbName, tableName, id, columnname);

                            //changeRow(dbName, tableName, id);

                        };
                    };
                    currentCell.onclick = createClickHandler(currentCell);
                }
            }

            function sortDifferents(differents) {
                differents.sort((a, b) => {
                    const textA = a.Text.toLowerCase();
                    const textB = b.Text.toLowerCase();

                    if (textA.includes('Nichtübereinstimmung') && !textB.includes('Nichtübereinstimmung')) {
                        return 1;
                    } else if (!textA.includes('Nichtübereinstimmung') && textB.includes('Nichtübereinstimmung')) {
                        return -1;
                    } else if (textA.includes('the foreign key') && !textB.includes('the foreign key')) {
                        return 1;
                    } else if (!textA.includes('the foreign key') && textB.includes('the foreign key')) {
                        return -1;
                    } else {
                        return 0;
                    }
                });
            }

            function createDifferentsTable(){
                let content = '';
                if (unvisitedIds != null){
                    if(unvisitedIds.left.length > 0 || unvisitedIds.right.length > 0){
                        content += `<div class="m-2 bg-yellow text-white p-1 rounded clickableUnvisited" role='button'> unvisited rows (not referenced) </div>`;
                    }
                }
                sortDifferents(differents);
                for (var i = 0; i < differents.length; i++){
                    var diff = differents[i];
                    content += `<div class="m-2 bg-yellow text-white p-1 rounded clickableDifferent" role='button' data-index="${i}"> ${diff.Text} </div>`;
                }
                $("#headerDivJsAfterUpdate").html(content);
                let menuIcon = document.querySelector('#menu-icon');
                menuIcon.innerText = menuIcon.innerText + ' (' + differents.length + ')';
                $("#headerDivJsAfterUpdate").find(".clickableDifferent").click(function(){
                    var diffIndex = $(this).data('index');
                    clearAllStyling();
                    selectDifferent(diffIndex);
                });
                $("#headerDivJsAfterUpdate").find(".clickableUnvisited").click(function(){
                    clearAllStyling();
                    selectUnvisited();
                });

            }
            function sortTablesByPath(tablePath) {
                let reversedTablePath = tablePath.reverse();
                let tablesDiv = document.getElementById('pageContentDiv');
                reversedTablePath.forEach((tableName) => {
                    let tablesTwinsDiv = document.getElementById(tableName + '-TablesTwinsDiv');

                    tablesDiv.removeChild(tablesTwinsDiv);
                    tablesDiv.insertBefore(tablesTwinsDiv, tablesDiv.firstChild);
                });
            }
            function addTablePathAsBreadcrumb(tablePath, differentIndex) {
                let breadcrumb = document.getElementById('breadcrumb');
                breadcrumb.parentElement.classList.remove('d-none');
                breadcrumb.setAttribute('data-different', differentIndex);
                breadcrumb.innerText = '';

                tablePath.reverse().forEach((tableName, index) => {
                    let pathItem = document.createElement('li');
                    pathItem.classList.add('breadcrumb-item');
                    pathItem.setAttribute('data-tableindex', index);

                    let pathLink = document.createElement('a');
                    pathLink.href = '#' + tableName + '-TablesTwinsDiv';
                    pathLink.innerText = tableName;

                    pathItem.appendChild(pathLink);
                    breadcrumb.appendChild(pathItem);
                });

                let items = document.querySelectorAll('.breadcrumb-item');
                items.forEach((item) => {
                    item.addEventListener('click', function(event) {
                        let breadcrumbItem = event.target.parentElement;
                        let diff = differents[Number(breadcrumbItem.parentElement.dataset.different)];
                        let tableIndex = Number(breadcrumbItem.dataset.tableindex);

                        scrollToRow(constLeftDB, diff.TablePath[tableIndex], diff.LeftIdPath[tableIndex]);
                        scrollToRow(constRightDB, diff.TablePath[tableIndex], diff.RightIdPath[tableIndex]);
                    });
                });
            }
            var differents = [];
            var unvisitedIds = null;
            function store_differents(data){
                differents = data.diff.reverse();
                unvisitedIds = data.unvisited;
                createDifferentsTable();
            }
            function compare_differents(data){
                var new_differents = data.diff;
                var new_unvisitedIds = data.unvisited;
                compareDifferentsTable(new_differents, new_unvisitedIds);
            }
            function compareDifferentsTable(new_differents, new_unvisitedIds){
                // bearbeitete Unterschiede streichen
                var cssClasses = ['bg-success', 'text-decoration-line-through']
                var oldDiffsDivs = $("#headerDivJsAfterUpdate").find('div.clickableDifferent');
                oldDiffsDivs.removeClass(cssClasses);
                for(var i = 0; i < differents.length; i++){
                    var found = false;
                    for (var n = 0; n < new_differents.length; n++){
                        if (differents[i].Text == new_differents[n].Text){
                            found = true;
                        }
                    }
                    if (!found){
                        oldDiffsDivs.filter(`[data-index='${i}']`).addClass(cssClasses);
                    }
                }
            }
            var lastSelectedDifferent = -1;
            function selectDifferent(index){
                if (index >= differents.length) {
                    console.log(index + ":index >= differents.length:" + differents.length);
                    debugger;
                    return;
                }
                lastSelectedDifferent = index;
                diff = differents[index];
                $('#current-different-div').html(diff.Text);

                sortTablesByPath(diff.TablePath);
                addTablePathAsBreadcrumb(diff.TablePath, index);

                for(var i = 0; i < diff.TablePath.length; i++){
                    var diffObj = {
                        'table' : diff.TablePath[i],
                        'leftId' : diff.LeftIdPath[i],
                        'rightId' : diff.RightIdPath[i],
                        'Columns' : diff.Columns
                    }

                    leftRightArray = [];
                    if (typeof diffObj.leftId != 'undefined') leftRightArray.push(constLeftDB);
                    if (typeof diffObj.rightId != 'undefined') leftRightArray.push(constRightDB);

                    handleDiffObj(changeRow, diffObj, leftRightArray);
                    if (i == diff.TablePath.length - 1) {
                        handleDiffObj(changeCell, diffObj, leftRightArray);
                    }
                }
            }
            function openFooter(db, tableName, rowid, columnname){
                if (lastSelectedDifferent > -1){
                    diff = differents[lastSelectedDifferent];
                    if (diff.TablePath.length > 0){
                        var lastIndex = diff.TablePath.length - 1;
                        if (diff.TablePath[lastIndex] == tableName){
                            if ($.inArray(columnname, diff.Columns) > -1){
                                var leftDiffCellClicked = db == constLeftDB && diff.LeftIdPath.length > lastIndex && diff.LeftIdPath[lastIndex] == rowid;
                                var rightDiffCellClicked = db == constRightDB && diff.RightIdPath.length > lastIndex && diff.RightIdPath[lastIndex] == rowid


                                if (leftDiffCellClicked || rightDiffCellClicked){
                                    var left = diff.LeftIdPath.length > lastIndex;
                                    var right = diff.RightIdPath.length > lastIndex;

                                    $('.showWhenLeft').toggle(left);
                                    $('.showWhenRight').toggle(right);
                                    $('.showWhenBoth').toggle(left && right);

                                    var leftCellId = -1;
                                    var rightCellId = -1;
                                    var leftValue = null;
                                    var rightValue = null;
                                    if (left){
                                        leftCellId = getCellId(constLeftDB, tableName, diff.LeftIdPath[lastIndex], columnname);
                                        leftValue = $('#' + leftCellId).text();
                                        changeInputText(constLeftDB, leftValue);
                                    }
                                    if (right){
                                        rightCellId = getCellId(constRightDB, tableName, diff.RightIdPath[lastIndex], columnname);
                                        rightValue = $('#' + rightCellId).text();
                                        changeInputText(right, rightValue);
                                    }
                                    if (left && right){
                                        post('jqp_fuzz_ratio',{'value_left' : leftValue, 'value_right' : rightValue}, (res) => {
                                            $('#quote').find('span').text(res.res);
                                            showFooter();
                                        });
                                    }
                                    else if (left || right){
                                        showFooter();
                                    }
                                    $('#save').off('click').click(()=>{
                                        var newLeftValue = $('#textAreaJsD1').val();
                                        var newRightValue = $('#textAreaJsD2').val();
                                        if (left && newLeftValue != leftValue){
                                            post('jqp_update_db', {'new_value' : newLeftValue, 'db_side' : constLeftDB, 'table_name' : tableName, 'row_id' : diff.LeftIdPath[lastIndex], 'column_name' : columnname}, (res)=>{
                                                $('#' + leftCellId).text(newLeftValue).prop('title', newLeftValue);
                                                leftValue = newLeftValue;
                                            });
                                        }
                                        if(right && newRightValue != rightValue){
                                            post('jqp_update_db', {'new_value' : newRightValue, 'db_side' : constRightDB, 'table_name' : tableName, 'row_id' : diff.RightIdPath[lastIndex], 'column_name' : columnname}, (res)=>{
                                                $('#' + rightCellId).text(newRightValue).prop('title', newRightValue);
                                                rightValue = newRightValue;
                                            });
                                        }
                                        function saved(n){
                                            // console.log(n);
                                            if (n > 100) return;
                                            var hide = true;
                                            if (right && rightValue != newRightValue) hide = false;
                                            if (left && leftValue != newLeftValue) hide = false;
                                            if (hide){
                                                hideFooter();
                                                post('jqp_get_differents', null, compare_differents);
                                            }
                                            else setTimeout(saved, 100, n+1);
                                        }
                                        setTimeout(saved, 100, 1);
                                    });
                                }
                            }
                        }
                    }
                }
            }
            function selectUnvisited(){
                $('#breadcrumb').parent().addClass('d-none');
                var leftTables = __selectUnvisited(constLeftDB, unvisitedIds.left);
                var rightTables = __selectUnvisited(constRightDB, unvisitedIds.right);
                $.extend(leftTables, rightTables);
                sortTablesByPath(leftTables);
            }
            function __selectUnvisited(leftOrRight, tables){
                var tablesArray = [];
                $.each(tables, function(){
                    var table = this.table;
                    tablesArray.push(table)
                    var ids = this.ids;
                    $.each(ids, function(){
                        changeRow(leftOrRight, table, this);
                    });
                });
                return tablesArray;
            }
            function handleDiffObj(f,diffObj, leftRightArray){
                for (var i = 0; i < leftRightArray.length; i++){
                    leftOrRight = leftRightArray[i];
                    var rowId = null;
                    if (leftOrRight == constLeftDB) rowId = diffObj.leftId;
                    else if (leftOrRight == constRightDB) rowId = diffObj.rightId;
                    else {
                        console.log('check value of leftRightArray: ' + leftRightArray);
                        debugger;
                    }
                    if (f == changeRow) changeRow(leftOrRight, diffObj.table, rowId);
                    else if (f == changeCell) {
                        for(var clmn_i = 0; clmn_i < diffObj.Columns.length; clmn_i++){
                            var column = diffObj.Columns[clmn_i];
                            changeCell(leftOrRight,diffObj.table,rowId, column, 'bg-danger');
                        }
                    }
                    else {
                        console.log('function-call not implemented found: ' + f);
                        debugger;
                    }
                }
            }
            function call_saveData(newValue, dbSide, tableName, rowId, columnName, callback_function){
                parameterObj = {'new_value':newValue, 'db_side':dbSide, 'table_name':tableName , 'row_id':rowId, 'column_name':columnName}
                post('jqp_update_db', parameterObj, callback_function);
            }
            function call_fuzz_ratio(value_left, value_right, callback_function){
                parameterObj = {'value_left':value_left, 'value_right':value_right}
                post('jqp_fuzz_ratio', parameterObj, callback_function);
            }
            function post(jqp_function, parameterObj, callback_function){
                if (!jqp_function.startsWith('jqp_')){
                    debugger;
                }

                jsonObj = {'jqp_function' : jqp_function};
                $.extend(jsonObj, parameterObj);
                var jqxhr = $.post("", jsonObj, function(data) {
                    // console.log(data);
                    if (callback_function != null) callback_function(data);
                })
                .fail(function(resp) {
                    if (typeof resp.responseText != "undefined")
                        alertError(resp.responseText);
                    else{
                        alertError('error while contacting the server');
                    }
                });
            }
            function alertError(msg){
                var errorDiv = $('#error-div');
                var newInnerDiv = $('<div>').append(msg);
                errorDiv.find('#err-text').append(newInnerDiv);
                errorDiv.show();
            }

            function with_parameters_example_clicked(dbName, tableName, row_id){
                var jqxhr = $.post("",{'jqp_function':'jqp_cell_clicked', 'table_name':tableName , 'row_id':row_id},function(data) {
                    console.log(data)
                })
                .done(function() {
                    //alert( "second success" );
                })
                .fail(function(resp) {
                    alertError(resp.responseText);
                })
                .always(function() {
                    //alert( "finished" );
                });
            }

            function changeCell(dbName, tableName, id, columnname, cssClass){
                var cellId = getCellId(dbName, tableName, id, columnname);
                $('#' + cellId).toggleClass(cssClass);
            }
            function scrollToRow(dbName, tableName, rowId) {
                if (rowId == null) return;

                let tableDiv = document.querySelector('#' + tableName + "-TableDiv-" + dbName);
                let scrollBody = tableDiv.querySelector('.dataTables_scrollBody');
                let row = tableDiv.querySelector('tr.rowId'+ rowId + "Js");
                scrollBody.scrollTop = row.offsetTop;
            }
            function changeRow(dbName, tableName, rowId){
                $('#' + tableName + "-TableDiv-" + dbName).find('tr.rowId'+ rowId + "Js").addClass('table-success');
                setTimeout(function() {
                    $('#' + getTableId(dbName, tableName)).DataTable().columns.adjust().draw();
                    scrollToRow(dbName, tableName, rowId);
                }, 1);
            }

            function changeInputText(db, value){
                if(db == constLeftDB){
                    var textArea = document.getElementById("textAreaJsD1");
                    textArea.value= value;

                }else{
                    var textArea = document.getElementById("textAreaJsD2");
                    textArea.value = value;
                }

            }


            function clearAllStyling(){
                let usedBSClassestoFind = "";

                usedBSClasses.forEach(element => {
                    usedBSClassestoFind += 'table .'+ element + ', ';
                });
                usedBSClassestoFind = usedBSClassestoFind.substring(0, usedBSClassestoFind.length - 2);
                var styledTages = document.querySelectorAll(usedBSClassestoFind);
                styledTages.forEach((element) => {
                    usedBSClasses.forEach(cla => {
                        element.classList.remove(cla);
                    })
                });
            }

            const menuIcon = document.getElementById('menu-icon');
            const menu = document.querySelector('.headerDiv');
            const main = document.querySelector('#main');
            const footer = document.querySelector('.footer');

            // Funktion, um das Menü anzuzeigen
            function showMenu() {
                menu.style.display = 'block';
                main.style.display = 'none';
                post('jqp_get_differents', null, compare_differents);
            }

            // Funktion, um das Menü auszublenden
            function hideMenu() {
                menu.style.display = 'none';
                main.style.display = 'block';
            }

            function showFooter() {
                footer.style.display = 'block';
            }

            // Funktion, um das Menü auszublenden
            function hideFooter() {
                footer.style.display = 'none';
            }

            // Klick auf das Symbol, um das Menü anzuzeigen
            menuIcon.addEventListener('click', showMenu);
            menuIcon.addEventListener('mouseover', ()=>{ if (lastSelectedDifferent > -1) $('#current-different-div').show();} );
            menuIcon.addEventListener('mouseout', ()=>{ $('#current-different-div').hide();} );

            // Klick außerhalb des Menüs, um es auszublenden
            document.addEventListener('click', function(event) {
                if (!menuIcon.contains(event.target) && event.target !== menu) {
                    hideMenu();
                }

                if (event.target == footer) {
                    hideFooter();
                }
            });
        });
    </script>
</body>

</html>